/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 24 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"

#include "api.h"
#include "lux.h"
#include "error.h"
#include "paramset.h"
#include "context.h"
#include <stdarg.h>
#include <sstream>

using namespace lux;

extern int yylex(void);
u_int lineNum = 0;
string currentFile;

#define YYMAXDEPTH 100000000

void yyerror(const char *str)
{
	std::stringstream ss;
	ss << "Parsing error";
	if (currentFile != "")
		ss << " in file '" << currentFile << "'";
	if (lineNum > 0)
		ss << " at line " << lineNum;
	ss << ": " << str;
	luxError(LUX_SYNTAX, LUX_SEVERE, ss.str().c_str());
}

class ParamListElem {
public:
	ParamListElem() : token(NULL), arg(NULL), size(0), textureHelper(false)
	{ }
	const char *token;
	void *arg;
	u_int size;
	bool textureHelper;
};
u_int curParamlistAllocated = 0;
u_int curParamlistSize = 0;
ParamListElem *curParamlists = NULL;

#define CPAL curParamlistAllocated
#define CPS curParamlistSize
#define CP curParamlists
#define CPT(__n) curParamlists[(__n)].token
#define CPA(__n) curParamlists[(__n)].arg
#define CPSZ(__n) curParamlists[(__n)].size
#define CPTH(__n) curParamlists[(__n)].textureHelper

class ParamArray {
public:
	ParamArray() : elementSize(0), allocated(0), nelems(0), array(NULL) { }
	u_int elementSize;
	u_int allocated;
	u_int nelems;
	void *array;
};

ParamArray *curArray = NULL;
bool arrayIsSingleString = false;

#define NA(r) ((float *) r->array)
#define SA(r) ((const char **) r->array)

void AddArrayElement(void *elem)
{
	if (curArray->nelems >= curArray->allocated) {
		curArray->allocated = 2 * curArray->allocated + 1;
		curArray->array = realloc(curArray->array,
			curArray->allocated * curArray->elementSize);
	}
	char *next = static_cast<char *>(curArray->array) +
		curArray->nelems * curArray->elementSize;
	memcpy(next, elem, curArray->elementSize);
	curArray->nelems++;
}

ParamArray *ArrayDup(ParamArray *ra)
{
	ParamArray *ret = new ParamArray;
	ret->elementSize = ra->elementSize;
	ret->allocated = ra->allocated;
	ret->nelems = ra->nelems;
	ret->array = malloc(ra->nelems * ra->elementSize);
	memcpy(ret->array, ra->array, ra->nelems * ra->elementSize);
	return ret;
}

void ArrayFree(ParamArray *ra)
{
	free(ra->array);
	delete ra;
}

void FreeArgs()
{
	for (u_int i = 0; i < CPS; ++i) {
		// NOTE - Ratow - freeing up strings inside string type args
		if (memcmp("string", CPT(i), 6) == 0 ||
			memcmp("texture", CPT(i), 7) == 0) {
			for (u_int j = 0; j < CPSZ(i); ++j)
				free(static_cast<char **>(CPA(i))[j]);
		}
		delete[] static_cast<char *>(CPA(i));
	}
}

static bool VerifyArrayLength(ParamArray *arr, u_int required,
	const char *command)
{
	if (arr->nelems != required) {
		std::stringstream ss;
		ss << command << " requires a(n) " << required <<
			" element array!";
		luxError(LUX_SYNTAX, LUX_SEVERE, ss.str().c_str());
		return false;
	}
	return true;
}
static void InitParamSet(ParamSet &ps, u_int count, ParamListElem *list);
#define YYPRINT(file, type, value)  \
{ \
	if ((type) == ID || (type) == STRING) \
		fprintf((file), " %s", (value).string); \
	else if ((type) == NUM) \
		fprintf((file), " %f", (value).num); \
}


/* Line 189 of yacc.c  */
#line 203 "/builddir/build/BUILD/lux-45f2ed7f09f7/build/luxparse.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     ID = 259,
     NUM = 260,
     LBRACK = 261,
     RBRACK = 262,
     ACCELERATOR = 263,
     AREALIGHTSOURCE = 264,
     ATTRIBUTEBEGIN = 265,
     ATTRIBUTEEND = 266,
     CAMERA = 267,
     CONCATTRANSFORM = 268,
     COORDINATESYSTEM = 269,
     COORDSYSTRANSFORM = 270,
     EXTERIOR = 271,
     FILM = 272,
     IDENTITY = 273,
     INTERIOR = 274,
     LIGHTSOURCE = 275,
     LOOKAT = 276,
     MATERIAL = 277,
     MAKENAMEDMATERIAL = 278,
     MAKENAMEDVOLUME = 279,
     NAMEDMATERIAL = 280,
     OBJECTBEGIN = 281,
     OBJECTEND = 282,
     OBJECTINSTANCE = 283,
     MOTIONINSTANCE = 284,
     LIGHTGROUP = 285,
     PIXELFILTER = 286,
     REVERSEORIENTATION = 287,
     ROTATE = 288,
     SAMPLER = 289,
     SCALE = 290,
     SEARCHPATH = 291,
     PORTALSHAPE = 292,
     SHAPE = 293,
     SURFACEINTEGRATOR = 294,
     TEXTURE = 295,
     TRANSFORMBEGIN = 296,
     TRANSFORMEND = 297,
     TRANSFORM = 298,
     TRANSLATE = 299,
     VOLUME = 300,
     VOLUMEINTEGRATOR = 301,
     WORLDBEGIN = 302,
     WORLDEND = 303,
     HIGH_PRECEDENCE = 304
   };
#endif
/* Tokens.  */
#define STRING 258
#define ID 259
#define NUM 260
#define LBRACK 261
#define RBRACK 262
#define ACCELERATOR 263
#define AREALIGHTSOURCE 264
#define ATTRIBUTEBEGIN 265
#define ATTRIBUTEEND 266
#define CAMERA 267
#define CONCATTRANSFORM 268
#define COORDINATESYSTEM 269
#define COORDSYSTRANSFORM 270
#define EXTERIOR 271
#define FILM 272
#define IDENTITY 273
#define INTERIOR 274
#define LIGHTSOURCE 275
#define LOOKAT 276
#define MATERIAL 277
#define MAKENAMEDMATERIAL 278
#define MAKENAMEDVOLUME 279
#define NAMEDMATERIAL 280
#define OBJECTBEGIN 281
#define OBJECTEND 282
#define OBJECTINSTANCE 283
#define MOTIONINSTANCE 284
#define LIGHTGROUP 285
#define PIXELFILTER 286
#define REVERSEORIENTATION 287
#define ROTATE 288
#define SAMPLER 289
#define SCALE 290
#define SEARCHPATH 291
#define PORTALSHAPE 292
#define SHAPE 293
#define SURFACEINTEGRATOR 294
#define TEXTURE 295
#define TRANSFORMBEGIN 296
#define TRANSFORMEND 297
#define TRANSFORM 298
#define TRANSLATE 299
#define VOLUME 300
#define VOLUMEINTEGRATOR 301
#define WORLDBEGIN 302
#define WORLDEND 303
#define HIGH_PRECEDENCE 304




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 154 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"

char string[1024];
float num;
ParamArray *ribarray;



/* Line 214 of yacc.c  */
#line 345 "/builddir/build/BUILD/lux-45f2ed7f09f7/build/luxparse.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 357 "/builddir/build/BUILD/lux-45f2ed7f09f7/build/luxparse.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   128

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  69
/* YYNRULES -- Number of states.  */
#define YYNSTATES  148

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     6,     7,     8,    10,    12,    14,
      16,    21,    24,    27,    29,    32,    34,    36,    41,    44,
      47,    49,    52,    55,    56,    59,    60,    63,    66,    68,
      72,    76,    78,    80,    84,    87,    90,    93,    96,   100,
     102,   105,   109,   113,   124,   128,   132,   137,   140,   143,
     145,   148,   154,   158,   160,   166,   170,   175,   178,   182,
     186,   190,   196,   198,   200,   203,   208,   212,   216,   218
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      51,     0,    -1,    70,    -1,    -1,    -1,    -1,    56,    -1,
      61,    -1,    57,    -1,    58,    -1,    52,     6,    59,     7,
      -1,    52,    60,    -1,    59,    60,    -1,    60,    -1,    53,
       3,    -1,    62,    -1,    63,    -1,    52,     6,    64,     7,
      -1,    52,    65,    -1,    64,    65,    -1,    65,    -1,    54,
       5,    -1,    67,    68,    -1,    -1,    69,    68,    -1,    -1,
       3,    55,    -1,    70,    71,    -1,    71,    -1,     8,     3,
      66,    -1,     9,     3,    66,    -1,    10,    -1,    11,    -1,
      12,     3,    66,    -1,    13,    61,    -1,    14,     3,    -1,
      15,     3,    -1,    16,     3,    -1,    17,     3,    66,    -1,
      18,    -1,    19,     3,    -1,    30,     3,    66,    -1,    20,
       3,    66,    -1,    21,     5,     5,     5,     5,     5,     5,
       5,     5,     5,    -1,    22,     3,    66,    -1,    23,     3,
      66,    -1,    24,     3,     3,    66,    -1,    25,     3,    -1,
      26,     3,    -1,    27,    -1,    28,     3,    -1,    29,     3,
       5,     5,     3,    -1,    31,     3,    66,    -1,    32,    -1,
      33,     5,     5,     5,     5,    -1,    34,     3,    66,    -1,
      35,     5,     5,     5,    -1,    36,     3,    -1,    38,     3,
      66,    -1,    37,     3,    66,    -1,    39,     3,    66,    -1,
      40,     3,     3,     3,    66,    -1,    41,    -1,    42,    -1,
      43,    62,    -1,    44,     5,     5,     5,    -1,    46,     3,
      66,    -1,    45,     3,    66,    -1,    47,    -1,    48,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   177,   177,   181,   189,   194,   199,   203,   208,   212,
     218,   223,   227,   230,   234,   240,   244,   249,   254,   258,
     261,   265,   271,   275,   280,   284,   287,   304,   307,   311,
     318,   325,   329,   333,   340,   346,   350,   354,   358,   365,
     369,   373,   380,   387,   391,   398,   405,   412,   416,   420,
     424,   428,   432,   439,   443,   447,   454,   458,   462,   469,
     476,   483,   490,   494,   498,   504,   508,   515,   522,   526
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "ID", "NUM", "LBRACK",
  "RBRACK", "ACCELERATOR", "AREALIGHTSOURCE", "ATTRIBUTEBEGIN",
  "ATTRIBUTEEND", "CAMERA", "CONCATTRANSFORM", "COORDINATESYSTEM",
  "COORDSYSTRANSFORM", "EXTERIOR", "FILM", "IDENTITY", "INTERIOR",
  "LIGHTSOURCE", "LOOKAT", "MATERIAL", "MAKENAMEDMATERIAL",
  "MAKENAMEDVOLUME", "NAMEDMATERIAL", "OBJECTBEGIN", "OBJECTEND",
  "OBJECTINSTANCE", "MOTIONINSTANCE", "LIGHTGROUP", "PIXELFILTER",
  "REVERSEORIENTATION", "ROTATE", "SAMPLER", "SCALE", "SEARCHPATH",
  "PORTALSHAPE", "SHAPE", "SURFACEINTEGRATOR", "TEXTURE", "TRANSFORMBEGIN",
  "TRANSFORMEND", "TRANSFORM", "TRANSLATE", "VOLUME", "VOLUMEINTEGRATOR",
  "WORLDBEGIN", "WORLDEND", "HIGH_PRECEDENCE", "$accept", "start",
  "array_init", "string_array_init", "num_array_init", "array",
  "string_array", "real_string_array", "single_element_string_array",
  "string_list", "string_list_entry", "num_array", "real_num_array",
  "single_element_num_array", "num_list", "num_list_entry", "paramlist",
  "paramlist_init", "paramlist_contents", "paramlist_entry",
  "ri_stmt_list", "ri_stmt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    50,    51,    52,    53,    54,    55,    55,    56,    56,
      57,    58,    59,    59,    60,    61,    61,    62,    63,    64,
      64,    65,    66,    67,    68,    68,    69,    70,    70,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     0,     0,     1,     1,     1,     1,
       4,     2,     2,     1,     2,     1,     1,     4,     2,     2,
       1,     2,     2,     0,     2,     0,     2,     2,     1,     3,
       3,     1,     1,     3,     2,     2,     2,     2,     3,     1,
       2,     3,     3,    10,     3,     3,     4,     2,     2,     1,
       2,     5,     3,     1,     5,     3,     4,     2,     3,     3,
       3,     5,     1,     1,     2,     4,     3,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,    31,    32,     0,     3,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,     0,     0,    62,    63,     3,     0,     0,     0,
      68,    69,     0,     2,    28,    23,    23,    23,     5,    34,
      15,    16,    35,    36,    37,    23,    40,    23,     0,    23,
      23,     0,    47,    48,    50,     0,    23,    23,     0,    23,
       0,    57,    23,    23,    23,     0,     0,    64,     0,    23,
      23,     1,    27,    29,    25,    30,    33,     5,     0,    18,
      38,    42,     0,    44,    45,    23,     0,    41,    52,     0,
      55,     0,    59,    58,    60,     0,     0,    67,    66,     3,
      22,    25,     5,    20,    21,     0,    46,     0,     0,    56,
      23,    65,     4,    26,     6,     8,     9,     7,    24,    17,
      19,     0,    51,    54,    61,     4,     0,    11,     0,     4,
      13,    14,     0,    10,    12,     0,     0,    43
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    42,    48,   136,    88,   123,   124,   125,   126,   139,
     137,    49,    50,    51,   112,    89,    83,    84,   110,   111,
      43,    44
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -133
static const yytype_int16 yypact[] =
{
      68,     5,     7,  -133,  -133,     9,  -133,    12,    13,    14,
      15,  -133,    16,    19,    20,    21,    27,    28,    29,    32,
    -133,    33,    34,    35,    36,  -133,    37,    38,    39,    40,
      42,    43,    44,    45,  -133,  -133,  -133,    46,    47,    50,
    -133,  -133,    54,    68,  -133,  -133,  -133,  -133,    49,  -133,
    -133,  -133,  -133,  -133,  -133,  -133,  -133,  -133,    51,  -133,
    -133,    55,  -133,  -133,  -133,    52,  -133,  -133,    56,  -133,
      57,  -133,  -133,  -133,  -133,    60,    49,  -133,    59,  -133,
    -133,  -133,  -133,  -133,    62,  -133,  -133,  -133,    61,  -133,
    -133,  -133,    63,  -133,  -133,  -133,    64,  -133,  -133,    65,
    -133,    66,  -133,  -133,  -133,    69,   112,  -133,  -133,  -133,
    -133,    62,    53,  -133,  -133,   113,  -133,    70,   114,  -133,
    -133,  -133,     0,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -133,   115,  -133,  -133,  -133,   116,   119,  -133,   118,   117,
    -133,  -133,   120,  -133,  -133,   121,   122,  -133
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -133,  -133,   -34,  -133,  -133,  -133,  -133,  -133,  -133,  -133,
    -132,   -69,    23,  -133,  -133,   -83,   -46,  -133,   -44,  -133,
    -133,    85
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -6
static const yytype_int16 yytable[] =
{
      85,    86,    76,   140,   113,    -5,   135,   144,    45,    90,
      46,    91,    47,    93,    94,    52,    53,    54,    55,    56,
      97,    98,    57,   100,    59,    58,   102,   103,   104,   130,
      60,    61,    62,   107,   108,    63,    64,    65,    66,    67,
     127,    69,    68,    71,    70,    72,    73,    74,    75,   116,
      79,    78,   113,    80,    81,    87,    92,    96,    95,    77,
     129,    99,   101,   105,   106,   109,   114,   128,   115,   117,
     118,   119,   120,   132,   134,   122,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,   121,   131,   133,
     138,    -5,   141,   142,   143,   145,   146,   147,    82
};

static const yytype_uint8 yycheck[] =
{
      46,    47,    36,   135,    87,     5,     6,   139,     3,    55,
       3,    57,     3,    59,    60,     3,     3,     3,     3,     3,
      66,    67,     3,    69,     3,     5,    72,    73,    74,   112,
       3,     3,     3,    79,    80,     3,     3,     3,     3,     3,
     109,     3,     5,     3,     5,     3,     3,     3,     3,    95,
       3,     5,   135,     3,     0,     6,     5,     5,     3,    36,
       7,     5,     5,     3,     5,     3,     5,   111,     5,     5,
       5,     5,     3,     3,   120,   109,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,     5,     5,     5,
       5,     5,     3,     5,     7,     5,     5,     5,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    51,    70,    71,     3,     3,     3,    52,    61,
      62,    63,     3,     3,     3,     3,     3,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       5,     3,     3,     3,     3,     3,    52,    62,     5,     3,
       3,     0,    71,    66,    67,    66,    66,     6,    54,    65,
      66,    66,     5,    66,    66,     3,     5,    66,    66,     5,
      66,     5,    66,    66,    66,     3,     5,    66,    66,     3,
      68,    69,    64,    65,     5,     5,    66,     5,     5,     5,
       3,     5,    52,    55,    56,    57,    58,    61,    68,     7,
      65,     5,     3,     5,    66,     6,    53,    60,     5,    59,
      60,     3,     5,     7,    60,     5,     5,     5
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 178 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 182 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	if (curArray)
		ArrayFree(curArray);
	curArray = new ParamArray;
	arrayIsSingleString = false;
}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 190 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	curArray->elementSize = sizeof(const char *);
}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 195 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	curArray->elementSize = sizeof(float);
}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 200 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = (yyvsp[(1) - (1)].ribarray);
}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 204 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = (yyvsp[(1) - (1)].ribarray);
}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 209 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = (yyvsp[(1) - (1)].ribarray);
}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 213 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = ArrayDup(curArray);
	arrayIsSingleString = true;
}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 219 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 224 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 228 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 231 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 235 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	char *toAdd = strdup((yyvsp[(2) - (2)].string));
	AddArrayElement(&toAdd);
}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 241 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = (yyvsp[(1) - (1)].ribarray);
}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 245 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 250 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 255 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 259 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 262 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 266 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	float toAdd = (yyvsp[(2) - (2)].num);
	AddArrayElement(&toAdd);
}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 272 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 276 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	CPS = 0;
}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 281 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 284 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 288 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	void *arg = new char[(yyvsp[(2) - (2)].ribarray)->nelems * (yyvsp[(2) - (2)].ribarray)->elementSize];
	memcpy(arg, (yyvsp[(2) - (2)].ribarray)->array, (yyvsp[(2) - (2)].ribarray)->nelems * (yyvsp[(2) - (2)].ribarray)->elementSize);
	if (CPS >= CPAL) {
		CPAL = 2 * CPAL + 1;
		CP = static_cast<ParamListElem *>(realloc(CP,
			CPAL * sizeof(ParamListElem)));
	}
	CPT(CPS) = (yyvsp[(1) - (2)].string);
	CPA(CPS) = arg;
	CPSZ(CPS) = (yyvsp[(2) - (2)].ribarray)->nelems;
	CPTH(CPS) = arrayIsSingleString;
	++CPS;
	ArrayFree((yyvsp[(2) - (2)].ribarray));
}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 305 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 308 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 312 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Accelerator((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 319 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->AreaLightSource((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 326 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxAttributeBegin();
}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 330 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxAttributeEnd();
}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 334 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Camera((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 341 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	if (VerifyArrayLength((yyvsp[(2) - (2)].ribarray), 16, "ConcatTransform"))
		luxConcatTransform(static_cast<float *>((yyvsp[(2) - (2)].ribarray)->array));
	ArrayFree((yyvsp[(2) - (2)].ribarray));
}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 347 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxCoordinateSystem((yyvsp[(2) - (2)].string));
}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 351 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxCoordSysTransform((yyvsp[(2) - (2)].string));
}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 355 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	Context::GetActive()->Exterior((yyvsp[(2) - (2)].string));
}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 359 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Film((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 366 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxIdentity();
}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 370 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	Context::GetActive()->Interior((yyvsp[(2) - (2)].string));
}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 374 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->LightGroup((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 381 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->LightSource((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 388 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxLookAt((yyvsp[(2) - (10)].num), (yyvsp[(3) - (10)].num), (yyvsp[(4) - (10)].num), (yyvsp[(5) - (10)].num), (yyvsp[(6) - (10)].num), (yyvsp[(7) - (10)].num), (yyvsp[(8) - (10)].num), (yyvsp[(9) - (10)].num), (yyvsp[(10) - (10)].num));
}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 392 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Material((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 399 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->MakeNamedMaterial((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 406 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->MakeNamedVolume((yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), params);
	FreeArgs();
}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 413 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	Context::GetActive()->NamedMaterial((yyvsp[(2) - (2)].string));
}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 417 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxObjectBegin((yyvsp[(2) - (2)].string));
}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 421 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxObjectEnd();
}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 425 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxObjectInstance((yyvsp[(2) - (2)].string));
}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 429 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxMotionInstance((yyvsp[(2) - (5)].string), (yyvsp[(3) - (5)].num), (yyvsp[(4) - (5)].num), (yyvsp[(5) - (5)].string));
}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 433 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->PixelFilter((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 440 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxReverseOrientation();
}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 444 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxRotate((yyvsp[(2) - (5)].num), (yyvsp[(3) - (5)].num), (yyvsp[(4) - (5)].num), (yyvsp[(5) - (5)].num));
}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 448 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Sampler((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 455 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxScale((yyvsp[(2) - (4)].num), (yyvsp[(3) - (4)].num), (yyvsp[(4) - (4)].num));
}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 459 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	;//luxSearchPath($2);//FIXME - Unimplemented
}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 463 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Shape((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 470 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->PortalShape((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 477 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->SurfaceIntegrator((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 484 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Texture((yyvsp[(2) - (5)].string), (yyvsp[(3) - (5)].string), (yyvsp[(4) - (5)].string), params);
	FreeArgs();
}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 491 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxTransformBegin();
}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 495 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxTransformEnd();
}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 499 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	if (VerifyArrayLength((yyvsp[(2) - (2)].ribarray), 16, "Transform"))
		luxTransform(static_cast<float *>((yyvsp[(2) - (2)].ribarray)->array));
	ArrayFree((yyvsp[(2) - (2)].ribarray));
}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 505 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxTranslate((yyvsp[(2) - (4)].num), (yyvsp[(3) - (4)].num), (yyvsp[(4) - (4)].num));
}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 509 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->VolumeIntegrator((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 516 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Volume((yyvsp[(2) - (3)].string), params);
	FreeArgs();
}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 523 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxWorldBegin();
}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 527 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"
    {
	luxWorldEnd();
}
    break;



/* Line 1464 of yacc.c  */
#line 2355 "/builddir/build/BUILD/lux-45f2ed7f09f7/build/luxparse.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 530 "/builddir/build/BUILD/lux-45f2ed7f09f7/core/luxparse.y"

static void InitParamSet(ParamSet &ps, u_int count, ParamListElem *list) {
	ps.Clear();
	for (u_int i = 0; i < count; ++i) {
		ParamType type;
		string name;
		if (!LookupType(list[i].token, &type, name)) {
			std::stringstream ss;
			ss << "Type of parameter '" << list[i].token <<
				"' is unknown";
			luxError(LUX_SYNTAX, LUX_WARNING, ss.str().c_str());
			continue;
		}
		if (list[i].textureHelper && type != PARAM_TYPE_TEXTURE &&
			type != PARAM_TYPE_STRING) {
			std::stringstream ss;
			ss << "Bad type for " << name <<
				". Changing it to a texture.";
			luxError(LUX_SYNTAX, LUX_WARNING, ss.str().c_str());
			type = PARAM_TYPE_TEXTURE;
		}
		void *data = list[i].arg;
		u_int nItems = list[i].size;
		if (type == PARAM_TYPE_INT) {
			// parser doesn't handle ints, so convert from floats
			int *idata = new int[nItems];
			float *fdata = static_cast<float *>(data);
			for (u_int j = 0; j < nItems; ++j)
				idata[j] = static_cast<int>(fdata[j]);
			ps.AddInt(name, idata, nItems);
			delete[] idata;
		} else if (type == PARAM_TYPE_BOOL) {
			// strings -> bools
			bool *bdata = new bool[nItems];
			for (u_int j = 0; j < nItems; ++j) {
				string s(*static_cast<const char **>(data));
				if (s == "true")
					bdata[j] = true;
				else if (s == "false")
					bdata[j] = false;
				else {
					std::stringstream ss;
					ss << "Value '" << s << "' unknown for boolean parameter '" <<
						list[i].token <<
						"'. Using 'false'.";
					luxError(LUX_SYNTAX, LUX_WARNING,
						ss.str().c_str());
					bdata[j] = false;
				}
			}
			ps.AddBool(name, bdata, nItems);
			delete[] bdata;
		} else if (type == PARAM_TYPE_FLOAT) {
			ps.AddFloat(name, static_cast<float *>(data), nItems);
		} else if (type == PARAM_TYPE_POINT) {
			ps.AddPoint(name, static_cast<Point *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_VECTOR) {
			ps.AddVector(name, static_cast<Vector *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_NORMAL) {
			ps.AddNormal(name, static_cast<Normal *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_COLOR) {
			ps.AddRGBColor(name, static_cast<RGBColor *>(data), nItems / COLOR_SAMPLES);
		} else if (type == PARAM_TYPE_STRING) {
			string *strings = new string[nItems];
			for (u_int j = 0; j < nItems; ++j)
				strings[j] = string(static_cast<const char **>(data)[j]);
			ps.AddString(name, strings, nItems);
			delete[] strings;
		} else if (type == PARAM_TYPE_TEXTURE) {
			if (nItems == 1) {
				string val(*static_cast<const char **>(data));
				ps.AddTexture(name, val);
			} else {
				std::stringstream ss;
				ss << "Only one string allowed for 'texture' parameter " << name;
				luxError(LUX_SYNTAX, LUX_ERROR,
					ss.str().c_str());
			}
		}
	}
}

